#include <bits/stdc++.h>

using namespace std;

#define int long long
#define float long double

pair<bool, vector<int>> dfs(int x, int s, int st, vector<bool> vis, vector<vector<int>> adj, vector<int> way) {
    if (vis[x] && x != st) return make_pair(false, way);
    s++;
    vis[x] = true;
    way.push_back(x);
    for (auto i : adj[x]) {
        if (!vis[i]) {
            pair<bool, vector<int>> res = dfs(i, s, st, vis, adj, way);
            if (res.first == true) return res;
        } else if (i == st && s % 2 == 1) {
            return make_pair(true, way);
        }
    } return make_pair(false, way);
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<vector<int>> adj(n + 1, vector<int>(0));
    for (int i = 1; i <= n; i++) {
        int a;
        cin >> a;
        if (adj[i].size() == 0) adj[i].push_back(a);
        else if (adj[i].size() == 1 && adj[i][0] != a) adj[i].push_back(a);
        if (adj[a].size() == 0) adj[a].push_back(i);
        else if (adj[a].size() == 1 && adj[a][0] != i) adj[a].push_back(i);
    } vector<bool> vis(n + 1, false);
    vector<int> zal1(0), zal2(0);
    int arest = 0, z = 1;
    for (int i = 1; i <= n; i++) {
        if (!vis[i]) {
            vis[i] = true;
            pair<bool, vector<int>> t = dfs(i, 0, i, vis, adj, {});
            //for (auto x : t.second) {
            //    cout << x << " ";
            //} cout << endl;
            if (t.first) {
                arest++;
                for (int j = 1; j < t.second.size(); j+=2) {
                    zal1.push_back(t.second[j]);
                    vis[t.second[j]] = true;
                } for (int j = 2; j < t.second.size(); j+=2) {
                    zal2.push_back(t.second[j]);
                    vis[t.second[j]] = true;
                }
            } else {
                //cout << "ok" << "\n";
                if (z == 1) {
                    zal1.push_back(i);
                    z = 2;
                } else {
                    zal2.push_back(i);
                    z = 1;
                }
            }
        }
    } cout << arest << '\n';
    for (int i = 0; i < zal1.size(); i++) {
        cout << zal1[i] << ' ';
    } cout << '\n';
    for (int i = 0; i < zal2.size(); i++) {
        cout << zal2[i] << ' ';
    }
}